#include "pack.h"
#include "util.h"
#include <stdio.h>
#include <stdlib.h>

// pack and unpack mat R, in which each element has two bits
void pack_mat_r(uint8_t *buf, const int16_t *data)
{
    for (size_t i = 0; i < PARAM_R_BYTES; i++)
    {
        buf[i] = ((data[0] & 0x03) << 6) | ((data[1] & 0x03) << 4) | ((data[2] & 0x03) << 2) | (data[3] & 0x03);
        data += 4;
    }
}

void unpack_mat_r_new(int16_t *data, const uint8_t *buf, int buf_len)
{
    for (size_t i = 0; i < (size_t)buf_len; i++)
    {
        data[0] = (buf[i] & 0xc0) >> 6;
        if (data[0] == 3)
        {
            data[0] = -1;
        }
        data[1] = (buf[i] & 0x30) >> 4;
        if (data[1] == 3)
        {
            data[1] = -1;
        }
        data[2] = (buf[i] & 0x0c) >> 2;
        if (data[2] == 3)
        {
            data[2] = -1;
        }
        data[3] = (buf[i] & 0x03);
        if (data[3] == 3)
        {
            data[3] = -1;
        }
        data += 4;
    }
}
