#!/bin/bash

submission_dir=$(pwd)

echo submission_dir=${submission_dir}

for NIST_Level in 1 3 5
do
    echo NIST_Level=${NIST_Level}

    for impl in "Reference_Implementation" "Optimized_Implementation" "Additional_Implementation/avx2"
    do
        cd $submission_dir/HuFu/$impl/crypto_sign/HuFu_NIST${NIST_Level}
        pwd
        make clean
        make all
        rm -rf *.r*
        for ver in "aes" "shake"
        do
            pwd >> $submission_dir/HuFu_NIST${NIST_Level}_${ver}.log
            echo >> $submission_dir/HuFu_NIST${NIST_Level}_${ver}.log
            ./main_${ver} >> $submission_dir/HuFu_NIST${NIST_Level}_${ver}.log
            { time ./PQCgenKAT_sign_${ver}; } 2>> $submission_dir/HuFu_NIST${NIST_Level}_${ver}.log
            echo >> $submission_dir/HuFu_NIST${NIST_Level}_${ver}.log
            for file in *[0-9].r*
            do
                mv "$file" "${file/./_${ver}.}"
            done
            sha256sum *_${ver}.r* >> $submission_dir/HuFu_NIST${NIST_Level}_${ver}.log
            echo "-------------">> $submission_dir/HuFu_NIST${NIST_Level}_${ver}.log
            echo >> $submission_dir/HuFu_NIST${NIST_Level}_${ver}.log
        done
        echo
    done
done

cd $submission_dir